<template>
    <div
        class="flex flex-row gap-x-10 grow"
    >
        <div class="grow">
            <p
                class="text-sm md:text-base prose pb-4 sm:pb-10 text-justify"
                :class="{'text-primary font-bold intro pb-8':intro}"
                v-on:click.stop="toggle_ref"
                v-html="data.rawValue"></p>
        </div>
        <div
            class="mt-5 xl:mt-0 absolute xl:relative text-xs xl:flex xl:flex-col grow-0 shrink-0 xl:w-128 gap-y-1 flex-none"
            >
            <div
                :id="ref.id"
                class="flex xl:flex-row flex-col items-end pr-4 xl:pr-0 xl:gap-x-1 invisible xl:visible"
                :class="{'hidden':references[ref.id].hidden}"
                v-for="ref in references"
                :key="ref.id"
            >
                <div 
                    class="grow-0 mb-1 xl:mb-8 h-fit xl:w-2/4 w-full box-border border border-primary px-4 py-2 rounded-md bg-primary drop-shadow-lg xl:shadow-none">
                    <p class="italic">{{ ref.abstract }}</p>
                    <p class="font-bold italic pt-2"> -
                        <span 
                            v-for="author, i in ref.author"
                            :key="author.family"
                            >
                            <span>{{ author.given }} {{ author.family }}</span>
                            <span v-if="i + 1 < ref.author.length">, </span>
                        </span>
                    </p>
                </div>
                <div class="grow-0 h-fit xl:w-2/4 w-full box-border border border-primary px-4 py-2 rounded-md bg-primary drop-shadow-lg xl:shadow-none">
                    <p class="italic">
                        <p>«{{ ref.title }}», {{ ref.publisher }} ({{ ref.issued["date-parts"][0][0] }})</p>
                    </p>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import Cite from 'citation-js'

export default {
    props: {
        data: {},
        intro: Boolean,
    },

    data() {
        return {
            references: {}
        }
    },

    mounted() {
        this.get_references()
    },

    methods: {
        get_references() {
            let parser = new DOMParser()
            let referencesParsed = Array.from(
                parser.parseFromString(
                    this.data.rawValue, 'text/html'
                ).getElementsByClassName('inlineReference')
            ).map(
                function(el) {
                    let cite = new Cite(el.attributes.data.value)
                    cite.data[0]['hidden'] = false
                    return cite
                })
            let keys = referencesParsed.map(element => element.data[0].id)
            let values = referencesParsed.map(element => element.data[0])
            this.references = keys.reduce((obj, k, i) => ({...obj, [k]: values[i] }), {})
        },

        toggle_ref(e) {
            let node = e.target
            while(node.nodeName !== "A"){
                node = node.parentNode
            }
            // if(e.target.)
            // let link = e.path.filter(el => el.nodeName === "A")
            let ref_id = node.id.replace('bibtexref-','')
            if(window.matchMedia('(max-width: 1024px)').matches){
                document.getElementById(ref_id).classList.toggle('invisible')
            }
            else {
                this.references[ref_id].hidden = !this.references[ref_id].hidden
            }
        }
    }
}
</script>

<style lang="postcss">
a.inlineReference {
    @apply no-underline text-primary !important;
}
.intro a.inlineReference {
    @apply text-black !important;
}
.visible {
    display: block;
}
</style>